<template>
  <div class="mt-bell">
    <b-dropdown
      ref="bell1"
      class="dropdown-bell"
      position="is-bottom-left"
      aria-role="list"
      @active-change="bellActiveChanged"
    >
      <button slot="trigger" class="cursor-as-pointer">
        <b-icon class="bell" icon="bell" />
        <mark v-show="alertesTotalNonLu > 0" class="mt-badge-alerte">
          {{ alertesTotalNonLu }}
        </mark>
      </button>

      <section v-if="alertes.size === 0" class="vide">
        Vous n'avez aucune alerte.
      </section>
      <section v-else>
        <mt-alertes
          v-for="(dateAlerte, index) in alertes.content"
          :key="index"
          v-slot="{ item: alerte }"
          :date-alerte="dateAlerte"
        >
          <mt-alerte
            :key="alerte.id"
            :alerte="alerte"
            :titre="tronquerAvec3Points(alerte.titre, 28)"
            :description="tronquerAvec3Points(alerte.description, 150)"
            :commentaire="tronquerAvec3Points(alerte.commentaire, 150)"
            @toggle="bellToggle"
          ></mt-alerte>
        </mt-alertes>
        <footer>
          <nuxt-link :to="{ name: 'alertes' }" @click.native="bellToggle">
            Tout afficher
          </nuxt-link>
        </footer>
      </section>
    </b-dropdown>
  </div>
</template>

<script>
import alerteMixin from '~/components/mixins/alerteMixin';
import userMixin from '~/components/mixins/userMixin';
import MtAlertes from '~/components/alerte/alertes';
import MtAlerte from '~/components/alerte/alerte';

export default {
  components: {
    MtAlerte,
    MtAlertes,
  },
  mixins: [alerteMixin, userMixin],
  data() {
    return {
      mtmodal1OuvertOK: false,
      alertes: {},
    };
  },
  computed: {
    alertesTotalNonLu() {
      return this.$store.state.alerte.nonLue;
    },
  },
  async created() {
    this.alertes = await this.$api.utilisateurs.alertes(6);
    await this.$store.dispatch('alerte/setNonLu', this.alertes.nonLue);
  },
  methods: {
    bellActiveChanged() {
      if (this.$refs.bell1.isActive) {
        this.refresh();
      }
    },
    async refresh() {
      await this.$api.utilisateurs.lireAlertes();
      this.alertes = await this.$api.utilisateurs.alertes(6);
      await this.$store.dispatch('alerte/setNonLu', this.alertes.nonLue);
    },
    bellToggle() {
      this.$refs.bell1.toggle();
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.dropdown-bell {
  /deep/.dropdown-content {
    width: 380px;
    border-radius: 4px;
    box-shadow: 0 2px 8px -2px rgba(164, 164, 164, 0.5);
    padding: 0;
  }

  button {
    border-style: none;
    background-color: unset;
    padding: 0;

    .bell {
      color: $grey-dark;
      position: relative;
      transition-property: color;
      transition-duration: 0.3s;
    }

    .mt-badge-alerte {
      position: absolute;
      top: 2px;
      right: -0.9em;
      font-size: 0.5rem;
    }

    &.is-active,
    &:hover {
      .bell {
        color: $soft-blue;
      }
    }
  }

  &.is-active {
    .bell {
      color: $soft-blue;
    }
  }

  .vide {
    padding: 3em 0;
    font-size: 0.9375rem;
    color: $grey-dark;
    text-align: center;
  }

  header {
    padding: 1em 2em;
    font-size: 0.9375rem;
    color: $grey-dark;

    .mt-badge-alerte {
      margin-left: 0.8rem;
      font-size: 0.875rem;
    }
  }

  footer {
    padding: 15px 0;
    text-align: center;
    font-size: 15px;
    color: $grey-dark;

    a:hover {
      text-decoration: underline;
    }
  }
  /*
  Responsive
   */
  @media screen and (max-width: 380px) {
    /deep/.dropdown-content {
      width: initial;
      max-width: 380px !important;
    }
  }
}
</style>
